#include <gsl_inline.h>
#include <gsl_pow_int.h>
#include <gsl_math.h>
#include <specfunc\gsl_sf.h>
#include <cblas\cblas.h>
#include <cheb\gsl_chebyshev.h>

#define WANT_WINDOWS_INCLUDES /* the sample implementation of this requires windows includes/libraries */
#define VENEXT_GLOBALS
#include "vensim.h"
#ifdef unix
#include <string.h>
#include <stdlib.h>
#else
#include <malloc.h>
#endif

GLOB_VARS *VENGV='\0'; /* the value for this is set by set_gv below */



/*******************************************
 1 - function ids - used to swich between choices 
 *******************************************/

#define FUNC_gsl_sf_airy_Ai 8
#define FUNC_gsl_sf_airy_Bi 9
#define FUNC_gsl_sf_airy_Ai_scaled 10
#define FUNC_gsl_sf_airy_Bi_scaled 11
#define FUNC_gsl_sf_airy_Ai_deriv 12
#define FUNC_gsl_sf_airy_Bi_deriv 13
#define FUNC_gsl_sf_airy_Ai_deriv_scaled 14
#define FUNC_gsl_sf_airy_Bi_deriv_scaled 15
#define FUNC_gsl_sf_airy_zero_Ai 16
#define FUNC_gsl_sf_airy_zero_Bi 17
#define FUNC_gsl_sf_airy_zero_Ai_deriv 18
#define FUNC_gsl_sf_airy_zero_Bi_deriv 19

#define FUNC_gsl_sf_bessel_J0 21
#define FUNC_gsl_sf_bessel_J1 22
#define FUNC_gsl_sf_bessel_Jn 23
#define FUNC_gsl_sf_bessel_Y0 24
#define FUNC_gsl_sf_bessel_Y1 25
#define FUNC_gsl_sf_bessel_Yn 26
#define FUNC_gsl_sf_bessel_I0 27
#define FUNC_gsl_sf_bessel_I1 28
#define FUNC_gsl_sf_bessel_In 29
#define FUNC_gsl_sf_bessel_I0_scaled 30
#define FUNC_gsl_sf_bessel_I1_scaled 31
#define FUNC_gsl_sf_bessel_In_scaled 32
#define FUNC_gsl_sf_bessel_K0 33
#define FUNC_gsl_sf_bessel_K1 34
#define FUNC_gsl_sf_bessel_Kn 35
#define FUNC_gsl_sf_bessel_K0_scaled 36
#define FUNC_gsl_sf_bessel_K1_scaled 37
#define FUNC_gsl_sf_bessel_Kn_scaled 38
//#define FUNC_gsl_sf_bessel_j0 39
//#define FUNC_gsl_sf_bessel_j1 40
#define FUNC_gsl_sf_bessel_j2 41
#define FUNC_gsl_sf_bessel_jl 42
//#define FUNC_gsl_sf_bessel_y0 43
//#define FUNC_gsl_sf_bessel_y1 44
#define FUNC_gsl_sf_bessel_y2 45
#define FUNC_gsl_sf_bessel_yl 46
//#define FUNC_gsl_sf_bessel_i0_scaled 47
//#define FUNC_gsl_sf_bessel_i1_scaled 48
#define FUNC_gsl_sf_bessel_i2_scaled 49
#define FUNC_gsl_sf_bessel_il_scaled 50
//#define FUNC_gsl_sf_bessel_k0_scaled 51
//#define FUNC_gsl_sf_bessel_k1_scaled 52
#define FUNC_gsl_sf_bessel_k2_scaled 53
#define FUNC_gsl_sf_bessel_kl_scaled 54
#define FUNC_gsl_sf_bessel_Jnu 55
#define FUNC_gsl_sf_bessel_Ynu 56
#define FUNC_gsl_sf_bessel_Inu_scaled 57
#define FUNC_gsl_sf_bessel_Inu 58
#define FUNC_gsl_sf_bessel_Knu_scaled 59
#define FUNC_gsl_sf_bessel_Knu 60
#define FUNC_gsl_sf_bessel_lnKnu 61
#define FUNC_gsl_sf_bessel_zero_J0 62
#define FUNC_gsl_sf_bessel_zero_J1 63
#define FUNC_gsl_sf_bessel_zero_Jnu 64

#define FUNC_gsl_sf_clausen 66


#define FUNC_gsl_sf_coupling_3j 69
#define FUNC_gsl_sf_coupling_6j 70
#define FUNC_gsl_sf_coupling_RacahW 71
#define FUNC_gsl_sf_coupling_9j 72
#define FUNC_gsl_sf_coupling_6j_INCORRECT 73

#define FUNC_gsl_sf_hydrogenicR_1 75
#define FUNC_gsl_sf_hydrogenicR 76

#define FUNC_gsl_sf_dawson 78

#define FUNC_gsl_sf_debye_1 80
#define FUNC_gsl_sf_debye_2 81
#define FUNC_gsl_sf_debye_3 82
#define FUNC_gsl_sf_debye_4 83
#define FUNC_gsl_sf_debye_5 84
#define FUNC_gsl_sf_debye_6 85

#define FUNC_gsl_sf_dilog 87

#define FUNC_gsl_sf_multiply 89

#define FUNC_gsl_sf_ellint_Kcomp 91
#define FUNC_gsl_sf_ellint_Ecomp 92
#define FUNC_gsl_sf_ellint_Pcomp 93
#define FUNC_gsl_sf_ellint_Dcomp 94
#define FUNC_gsl_sf_ellint_F 95
#define FUNC_gsl_sf_ellint_E 96
#define FUNC_gsl_sf_ellint_P 97
#define FUNC_gsl_sf_ellint_D 98
#define FUNC_gsl_sf_ellint_RC 99
#define FUNC_gsl_sf_ellint_RD 100
#define FUNC_gsl_sf_ellint_RF 101
#define FUNC_gsl_sf_ellint_RJ 102

#define FUNC_gsl_sf_erfc 104

#define FUNC_gsl_sf_log_erfc 106
#define FUNC_gsl_sf_erf 107
#define FUNC_gsl_sf_erf_Z 108
#define FUNC_gsl_sf_erf_Q 109
#define FUNC_gsl_sf_hazard 110


#define FUNC_gsl_sf_exp 113

#define FUNC_gsl_sf_exp_mult 115
#define FUNC_gsl_sf_expm1 116
#define FUNC_gsl_sf_exprel 117
#define FUNC_gsl_sf_exprel_2 118
#define FUNC_gsl_sf_exprel_n 119

#define FUNC_gsl_sf_expint_E1 121
#define FUNC_gsl_sf_expint_E2 122
#define FUNC_gsl_sf_expint_En 123
#define FUNC_gsl_sf_expint_E1_scaled 124
#define FUNC_gsl_sf_expint_E2_scaled 125
#define FUNC_gsl_sf_expint_En_scaled 126
#define FUNC_gsl_sf_expint_Ei 127
#define FUNC_gsl_sf_expint_Ei_scaled 128
#define FUNC_gsl_sf_Shi 129
#define FUNC_gsl_sf_Chi 130
#define FUNC_gsl_sf_expint_3 131
#define FUNC_gsl_sf_Si 132
#define FUNC_gsl_sf_Ci 133
#define FUNC_gsl_sf_atanint 134


#define FUNC_gsl_sf_fermi_dirac_m1 137
#define FUNC_gsl_sf_fermi_dirac_0 138
#define FUNC_gsl_sf_fermi_dirac_1 139
#define FUNC_gsl_sf_fermi_dirac_2 140
#define FUNC_gsl_sf_fermi_dirac_int 141
#define FUNC_gsl_sf_fermi_dirac_mhalf 142
#define FUNC_gsl_sf_fermi_dirac_half 143
#define FUNC_gsl_sf_fermi_dirac_3half 144
#define FUNC_gsl_sf_fermi_dirac_inc_0 145

#define FUNC_gsl_sf_lngamma 147
#define FUNC_gsl_sf_gamma 148
#define FUNC_gsl_sf_gammastar 149
#define FUNC_gsl_sf_gammainv 150
#define FUNC_gsl_sf_taylorcoeff 151
#define FUNC_gsl_sf_fact 152
#define FUNC_gsl_sf_doublefact 153
#define FUNC_gsl_sf_lnfact 154
#define FUNC_gsl_sf_lndoublefact 155
#define FUNC_gsl_sf_lnchoose 156
#define FUNC_gsl_sf_choose 157
#define FUNC_gsl_sf_lnpoch 158
#define FUNC_gsl_sf_poch 159
#define FUNC_gsl_sf_pochrel 160
#define FUNC_gsl_sf_gamma_inc_Q 161
#define FUNC_gsl_sf_gamma_inc_P 162
#define FUNC_gsl_sf_gamma_inc 163
#define FUNC_gsl_sf_lnbeta 164
#define FUNC_gsl_sf_beta 165
#define FUNC_gsl_sf_beta_inc 166

#define FUNC_gsl_sf_gegenpoly_1 168
#define FUNC_gsl_sf_gegenpoly_2 169
#define FUNC_gsl_sf_gegenpoly_3 170
#define FUNC_gsl_sf_gegenpoly_n 171

#define FUNC_gsl_sf_hermite_prob 173
#define FUNC_gsl_sf_hermite_prob_der 174
#define FUNC_gsl_sf_hermite_phys 175
#define FUNC_gsl_sf_hermite_phys_der 176
#define FUNC_gsl_sf_hermite_func 177
#define FUNC_gsl_sf_hermite_prob_series 178
#define FUNC_gsl_sf_hermite_phys_series 179
#define FUNC_gsl_sf_hermite_func_series 180
#define FUNC_gsl_sf_hermite_func_der 181
#define FUNC_gsl_sf_hermite_prob_zero 182
#define FUNC_gsl_sf_hermite_phys_zero 183
#define FUNC_gsl_sf_hermite_func_zero 184

#define FUNC_gsl_sf_laguerre_1 186
#define FUNC_gsl_sf_laguerre_2 187
#define FUNC_gsl_sf_laguerre_3 188
#define FUNC_gsl_sf_laguerre_n 189

#define FUNC_gsl_sf_lambert_W0 191
#define FUNC_gsl_sf_lambert_Wm1 192

#define FUNC_gsl_sf_log 194
#define FUNC_gsl_sf_log_abs 195
#define FUNC_gsl_sf_log_1plusx 196
#define FUNC_gsl_sf_log_1plusx_mx 197

#define FUNC_gsl_sf_pow_int 199

#define FUNC_gsl_sf_psi_int 201
#define FUNC_gsl_sf_psi 202
#define FUNC_gsl_sf_psi_1piy 203
#define FUNC_gsl_sf_psi_1_int 204
#define FUNC_gsl_sf_psi_1 205
#define FUNC_gsl_sf_psi_n 206

#define FUNC_gsl_sf_synchrotron_1 208
#define FUNC_gsl_sf_synchrotron_2 209

#define FUNC_gsl_sf_transport_2 211
#define FUNC_gsl_sf_transport_3 212
#define FUNC_gsl_sf_transport_4 213
#define FUNC_gsl_sf_transport_5 214

#define FUNC_gsl_sf_sin 216
#define FUNC_gsl_sf_cos 217
#define FUNC_gsl_sf_hypot 218
#define FUNC_gsl_sf_sinc 219
#define FUNC_gsl_sf_lnsinh 220
#define FUNC_gsl_sf_lncosh 221
#define FUNC_gsl_sf_angle_restrict_symm 222
#define FUNC_gsl_sf_angle_restrict_pos 223

#define FUNC_gsl_sf_zeta_int 225
#define FUNC_gsl_sf_zeta 226
#define FUNC_gsl_sf_zetam1 227
#define FUNC_gsl_sf_zetam1_int 228
#define FUNC_gsl_sf_hzeta 229
#define FUNC_gsl_sf_eta_int 230
#define FUNC_gsl_sf_eta 231

#define FUNC_gsl_sf_hyperg_0F1				232
#define FUNC_gsl_sf_hyperg_1F1				233
#define FUNC_gsl_sf_hyperg_U				234
#define FUNC_gsl_sf_hyperg_2F1				235
#define FUNC_gsl_sf_hyperg_2F1_conj			236
#define FUNC_gsl_sf_hyperg_2F1_renorm		237
#define FUNC_gsl_sf_hyperg_2F1_conj_renorm	238
#define FUNC_gsl_sf_hyperg_2F0				239

//#define FUNC_gsl_cheb_alloc					240


/*
double gsl_sf_airy_Ai(const double x, GSL_PREC_DOUBLE);
double gsl_sf_airy_Bi(const double x, GSL_PREC_DOUBLE);
double gsl_sf_airy_Ai_scaled(const double x, GSL_PREC_DOUBLE);
double gsl_sf_airy_Bi_scaled(const double x, GSL_PREC_DOUBLE);
double gsl_sf_airy_Ai_deriv(const double x, GSL_PREC_DOUBLE);
double gsl_sf_airy_Bi_deriv(const double x, GSL_PREC_DOUBLE);
double gsl_sf_airy_Ai_deriv_scaled(const double x, GSL_PREC_DOUBLE);
double gsl_sf_airy_Bi_deriv_scaled(const double x, GSL_PREC_DOUBLE);
double gsl_sf_airy_zero_Ai(unsigned int s);
double gsl_sf_airy_zero_Bi(unsigned int s);
double gsl_sf_airy_zero_Ai_deriv(unsigned int s);
double gsl_sf_airy_zero_Bi_deriv(unsigned int s);

double gsl_sf_bessel_J0(const double x);
double gsl_sf_bessel_J1(const double x);
double gsl_sf_bessel_Jn(const int n, const double x);
double gsl_sf_bessel_Y0(const double x);
double gsl_sf_bessel_Y1(const double x);
double gsl_sf_bessel_Yn(const int n,const double x);
double gsl_sf_bessel_I0(const double x);
double gsl_sf_bessel_I1(const double x);
double gsl_sf_bessel_In(const int n, const double x);
double gsl_sf_bessel_I0_scaled(const double x);
double gsl_sf_bessel_I1_scaled(const double x);
double gsl_sf_bessel_In_scaled(const int n, const double x);
double gsl_sf_bessel_K0(const double x);
double gsl_sf_bessel_K1(const double x);
double gsl_sf_bessel_Kn(const int n, const double x);
double gsl_sf_bessel_K0_scaled(const double x);
double gsl_sf_bessel_K1_scaled(const double x);
double gsl_sf_bessel_Kn_scaled(const int n, const double x);
double gsl_sf_bessel_j0(const double x);
double gsl_sf_bessel_j1(const double x);
double gsl_sf_bessel_j2(const double x);
double gsl_sf_bessel_jl(const int l, const double x);
double gsl_sf_bessel_y0(const double x);
double gsl_sf_bessel_y1(const double x);
double gsl_sf_bessel_y2(const double x);
double gsl_sf_bessel_yl(const int l, const double x);
double gsl_sf_bessel_i0_scaled(const double x);
double gsl_sf_bessel_i1_scaled(const double x);
double gsl_sf_bessel_i2_scaled(const double x);
double gsl_sf_bessel_il_scaled(const int l, const double x);
double gsl_sf_bessel_k0_scaled(const double x);
double gsl_sf_bessel_k1_scaled(const double x);
double gsl_sf_bessel_k2_scaled(const double x);
double gsl_sf_bessel_kl_scaled(const int l, const double x);
double gsl_sf_bessel_Jnu(const double nu, const double x);
double gsl_sf_bessel_Ynu(const double nu, const double x);
double gsl_sf_bessel_Inu_scaled(double nu, double x);
double gsl_sf_bessel_Inu(double nu, double x);
double gsl_sf_bessel_Knu_scaled(const double nu, const double x);
double gsl_sf_bessel_Knu(const double nu, const double x);
double gsl_sf_bessel_lnKnu(const double nu, const double x);
double gsl_sf_bessel_zero_J0(unsigned int s);
double gsl_sf_bessel_zero_J1(unsigned int s);
double gsl_sf_bessel_zero_Jnu(double nu, unsigned int s);

double gsl_sf_clausen(const double x);


double gsl_sf_coupling_3j(int two_ja, int two_jb, int two_jc, int two_ma, int two_mb, int two_mc );
double gsl_sf_coupling_6j(int two_ja, int two_jb, int two_jc, int two_jd, int two_je, int two_jf );
double gsl_sf_coupling_RacahW(int two_ja, int two_jb, int two_jc, int two_jd, int two_je, int two_jf);
double gsl_sf_coupling_9j(int two_ja, int two_jb, int two_jc, int two_jd, int two_je, int two_jf, int two_jg, int two_jh, int two_ji );
double gsl_sf_coupling_6j_INCORRECT(int two_ja, int two_jb, int two_jc, int two_jd, int two_je, int two_jf );

double gsl_sf_hydrogenicR_1(const double Z, const double r);
double gsl_sf_hydrogenicR(const int n, const int l, const double Z, const double r);

double     gsl_sf_dawson(double x);

double     gsl_sf_debye_1(const double x);
double     gsl_sf_debye_2(const double x);
double     gsl_sf_debye_3(const double x);
double     gsl_sf_debye_4(const double x);
double     gsl_sf_debye_5(const double x);
double     gsl_sf_debye_6(const double x);

double  gsl_sf_dilog(const double x);

double gsl_sf_multiply(const double x, const double y);

double gsl_sf_ellint_Kcomp(double k, GSL_PREC_DOUBLE);
double gsl_sf_ellint_Ecomp(double k, GSL_PREC_DOUBLE);
double gsl_sf_ellint_Pcomp(double k, double n, GSL_PREC_DOUBLE);
double gsl_sf_ellint_Dcomp(double k, GSL_PREC_DOUBLE);
double gsl_sf_ellint_F(double phi, double k, GSL_PREC_DOUBLE);
double gsl_sf_ellint_E(double phi, double k, GSL_PREC_DOUBLE);
double gsl_sf_ellint_P(double phi, double k, double n, GSL_PREC_DOUBLE);
double gsl_sf_ellint_D(double phi, double k, GSL_PREC_DOUBLE);
double gsl_sf_ellint_RC(double x, double y, GSL_PREC_DOUBLE);
double gsl_sf_ellint_RD(double x, double y, double z, GSL_PREC_DOUBLE);
double gsl_sf_ellint_RF(double x, double y, double z, GSL_PREC_DOUBLE);
double gsl_sf_ellint_RJ(double x, double y, double z, double p, GSL_PREC_DOUBLE);

double gsl_sf_erfc(double x);

double gsl_sf_log_erfc(double x);
double gsl_sf_erf(double x);
double gsl_sf_erf_Z(double x);
double gsl_sf_erf_Q(double x);
double gsl_sf_hazard(double x);


double gsl_sf_exp(const double x);

double gsl_sf_exp_mult(const double x, const double y);
double gsl_sf_expm1(const double x);
double gsl_sf_exprel(const double x);
double gsl_sf_exprel_2(const double x);
double gsl_sf_exprel_n(const int n, const double x);

double  gsl_sf_expint_E1(const double x);
double  gsl_sf_expint_E2(const double x);
double  gsl_sf_expint_En(const int n, const double x);
double  gsl_sf_expint_E1_scaled(const double x);
double  gsl_sf_expint_E2_scaled(const double x);
double  gsl_sf_expint_En_scaled(const int n, const double x);
double  gsl_sf_expint_Ei(const double x);
double  gsl_sf_expint_Ei_scaled(const double x);
double  gsl_sf_Shi(const double x);
double  gsl_sf_Chi(const double x);
double  gsl_sf_expint_3(double x);
double  gsl_sf_Si(const double x);
double  gsl_sf_Ci(const double x);
double  gsl_sf_atanint(const double x);


double     gsl_sf_fermi_dirac_m1(const double x);
double     gsl_sf_fermi_dirac_0(const double x);
double     gsl_sf_fermi_dirac_1(const double x);
double     gsl_sf_fermi_dirac_2(const double x);
double     gsl_sf_fermi_dirac_int(const int j, const double x);
double     gsl_sf_fermi_dirac_mhalf(const double x);
double     gsl_sf_fermi_dirac_half(const double x);
double     gsl_sf_fermi_dirac_3half(const double x);
double     gsl_sf_fermi_dirac_inc_0(const double x, const double b);

double gsl_sf_lngamma(const double x);
double gsl_sf_gamma(const double x);
double gsl_sf_gammastar(const double x);
double gsl_sf_gammainv(const double x);
double gsl_sf_taylorcoeff(const int n, const double x);
double gsl_sf_fact(const unsigned int n);
double gsl_sf_doublefact(const unsigned int n);
double gsl_sf_lnfact(const unsigned int n);
double gsl_sf_lndoublefact(const unsigned int n);
double gsl_sf_lnchoose(unsigned int n, unsigned int m);
double gsl_sf_choose(unsigned int n, unsigned int m);
double gsl_sf_lnpoch(const double a, const double x);
double gsl_sf_poch(const double a, const double x);
double gsl_sf_pochrel(const double a, const double x);
double gsl_sf_gamma_inc_Q(const double a, const double x);
double gsl_sf_gamma_inc_P(const double a, const double x);
double gsl_sf_gamma_inc(const double a, const double x);
double gsl_sf_lnbeta(const double a, const double b);
double gsl_sf_beta(const double a, const double b);
double gsl_sf_beta_inc(const double a, const double b, const double x);

double gsl_sf_gegenpoly_1(double lambda, double x);
double gsl_sf_gegenpoly_2(double lambda, double x);
double gsl_sf_gegenpoly_3(double lambda, double x);
double gsl_sf_gegenpoly_n(int n, double lambda, double x);

double gsl_sf_hermite_prob(const int n, const double x);
double gsl_sf_hermite_prob_der(const int m, const int n, const double x);
double gsl_sf_hermite_phys(const int n, const double x);
double gsl_sf_hermite_phys_der(const int m, const int n, const double x);
double gsl_sf_hermite_func(const int n, const double x);
double gsl_sf_hermite_prob_series(const int n, const double x, const double * a);
double gsl_sf_hermite_phys_series(const int n, const double x, const double * a);
double gsl_sf_hermite_func_series(const int n, const double x, const double * a);
double gsl_sf_hermite_func_der(const int m, const int n, const double x);
double gsl_sf_hermite_prob_zero(const int n, const int s);
double gsl_sf_hermite_phys_zero(const int n, const int s);
double gsl_sf_hermite_func_zero(const int n, const int s);

double gsl_sf_laguerre_1(double a, double x);
double gsl_sf_laguerre_2(double a, double x);
double gsl_sf_laguerre_3(double a, double x);
double     gsl_sf_laguerre_n(int n, double a, double x);

double  gsl_sf_lambert_W0(double x);
double  gsl_sf_lambert_Wm1(double x);

double gsl_sf_log(const double x);
double gsl_sf_log_abs(const double x);
double gsl_sf_log_1plusx(const double x);
double gsl_sf_log_1plusx_mx(const double x);

double  gsl_sf_pow_int(const double x, const int n);

double  gsl_sf_psi_int(const int n);
double  gsl_sf_psi(const double x);
double  gsl_sf_psi_1piy(const double y);
double  gsl_sf_psi_1_int(const int n);
double  gsl_sf_psi_1(const double x);
double  gsl_sf_psi_n(const int n, const double x);

double     gsl_sf_synchrotron_1(const double x);
double     gsl_sf_synchrotron_2(const double x);

double     gsl_sf_transport_2(const double x);
double     gsl_sf_transport_3(const double x);
double     gsl_sf_transport_4(const double x);
double     gsl_sf_transport_5(const double x);

double gsl_sf_sin(const double x);
double gsl_sf_cos(const double x);
double gsl_sf_hypot(const double x, const double y);
double gsl_sf_sinc(const double x);
double gsl_sf_lnsinh(const double x);
double gsl_sf_lncosh(const double x);
double gsl_sf_angle_restrict_symm(const double theta);
double gsl_sf_angle_restrict_pos(const double theta);

double gsl_sf_zeta_int(const int n);
double gsl_sf_zeta(const double s);
double gsl_sf_zetam1(const double s);
double gsl_sf_zetam1_int(const int s);
double gsl_sf_hzeta(const double s, const double q);
double gsl_sf_eta_int(const int n);
double gsl_sf_eta(const double s);

*/


/*******************************************
 2 - function prototypes 
 *******************************************
  each external function is prototyped here
  arguments can reasonably be doubles - for normal number manipulation,
  COMPREAL * for vector manipulation or int for indexing.  Recasting of
  values takes place in 
  Note that if you use more than 1 file for the external function definitions
  you should probably put these prototypes into a #include file.  Also, for
  working with compiled simulation a # include file is helpfule, and should
  be nested into vensim.h

  Note that all the external functions are all upper case.  This is required
  if you want to use compile simulations - since the calls in mdl.c will
  be upper case.  Our apologies to those this offends.
*********************************************/

/****************************************************
 3 - Grouping of functions in a structure - see venext.h
 ***********************************************************/

static FUNC_DESC Flist[] = {

	{ "gsl_sf_hyperg_0F1", "{c} , {x} ", 2, 0, FUNC_gsl_sf_hyperg_0F1, 0, 0, 0, 0 },
	{ "gsl_sf_hyperg_1F1", "{a} , {b} , {x} ", 3, 0, FUNC_gsl_sf_hyperg_1F1,0,0,0,0 },
	{ "gsl_sf_hyperg_U", "{a} , {b} , {x} ", 3, 0, FUNC_gsl_sf_hyperg_U,0,0,0,0 },
	{ "gsl_sf_hyperg_2F1", "{a} , {b} , {c} , {x} ", 4, 0, FUNC_gsl_sf_hyperg_2F1,0,0,0,0 },
	{ "gsl_sf_hyperg_2F1_conj", "{aR} , {aI} , {c} , {x} ", 4, 0, FUNC_gsl_sf_hyperg_2F1_conj,0,0,0,0 },
	{ "gsl_sf_hyperg_2F1_renorm", "{a} , {b} , {c} , {x} ", 4, 0, FUNC_gsl_sf_hyperg_2F1_renorm,0,0,0,0 },
	{ "gsl_sf_hyperg_2F1_conj_renorm", "{aR} , {aI} , {c} , {x} ", 4, 0, FUNC_gsl_sf_hyperg_2F1_conj_renorm,0,0,0,0 },
	{ "gsl_sf_hyperg_2F0", "{a}, {b}, {x} ", 3, 0, FUNC_gsl_sf_hyperg_2F0,0,0,0,0 },

	{ "gsl_sf_airy_Ai","{ x }",1, 0, FUNC_gsl_sf_airy_Ai,0,0,0,0 },
	{ "gsl_sf_airy_Bi","{ x }",1, 0, FUNC_gsl_sf_airy_Bi,0,0,0,0 },
	{ "gsl_sf_airy_Ai_scaled","{ x }",1, 0, FUNC_gsl_sf_airy_Ai_scaled,0,0,0,0 },
	{ "gsl_sf_airy_Bi_scaled","{ x }",1, 0, FUNC_gsl_sf_airy_Bi_scaled,0,0,0,0 },
	{ "gsl_sf_airy_Ai_deriv","{ x }",1, 0, FUNC_gsl_sf_airy_Ai_deriv,0,0,0,0 },
	{ "gsl_sf_airy_Bi_deriv","{ x }",1, 0, FUNC_gsl_sf_airy_Bi_deriv,0,0,0,0 },
	{ "gsl_sf_airy_Ai_deriv_scaled","{ x }",1, 0, FUNC_gsl_sf_airy_Ai_deriv_scaled,0,0,0,0 },
	{ "gsl_sf_airy_Bi_deriv_scaled","{ x }",1, 0, FUNC_gsl_sf_airy_Bi_deriv_scaled,0,0,0,0 },
	{ "gsl_sf_airy_zero_Ai","{ s }",1, 0, FUNC_gsl_sf_airy_zero_Ai,0,0,0,0 },
	{ "gsl_sf_airy_zero_Bi","{ s }",1, 0, FUNC_gsl_sf_airy_zero_Bi,0,0,0,0 },
	{ "gsl_sf_airy_zero_Ai_deriv","{ s }",1, 0, FUNC_gsl_sf_airy_zero_Ai_deriv,0,0,0,0 },
	{ "gsl_sf_airy_zero_Bi_deriv","{ s }",1, 0, FUNC_gsl_sf_airy_zero_Bi_deriv,0,0,0,0 },

	{ "gsl_sf_bessel_J0","{ x }",1, 0, FUNC_gsl_sf_bessel_J0,0,0,0,0 },
	{ "gsl_sf_bessel_J1","{ x }",1, 0, FUNC_gsl_sf_bessel_J1,0,0,0,0 },
	{ "gsl_sf_bessel_Jn","{ n } , { x }",2, 0, FUNC_gsl_sf_bessel_Jn,0,0,0,0 },
	{ "gsl_sf_bessel_Y0","{ x }",1, 0, FUNC_gsl_sf_bessel_Y0,0,0,0,0 },
	{ "gsl_sf_bessel_Y1","{ x }",1, 0, FUNC_gsl_sf_bessel_Y1,0,0,0,0 },
	{ "gsl_sf_bessel_Yn","{ n } , { x }",2, 0, FUNC_gsl_sf_bessel_Yn,0,0,0,0 },
	{ "gsl_sf_bessel_I0","{ x }",1, 0, FUNC_gsl_sf_bessel_I0,0,0,0,0 },
	{ "gsl_sf_bessel_I1","{ x }",1, 0, FUNC_gsl_sf_bessel_I1,0,0,0,0 },
	{ "gsl_sf_bessel_In","{ n } , { x }",2, 0, FUNC_gsl_sf_bessel_In,0,0,0,0 },
	{ "gsl_sf_bessel_I0_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_I0_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_I1_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_I1_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_In_scaled","{ n } , { x }",2, 0, FUNC_gsl_sf_bessel_In_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_K0","{ x }",1, 0, FUNC_gsl_sf_bessel_K0,0,0,0,0 },
	{ "gsl_sf_bessel_K1","{ x }",1, 0, FUNC_gsl_sf_bessel_K1,0,0,0,0 },
	{ "gsl_sf_bessel_Kn","{ n } , { x }",2, 0, FUNC_gsl_sf_bessel_Kn,0,0,0,0 },
	{ "gsl_sf_bessel_K0_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_K0_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_K1_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_K1_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_Kn_scaled","{ n } , { x }",2, 0, FUNC_gsl_sf_bessel_Kn_scaled,0,0,0,0 },
	//{ "gsl_sf_bessel_j0","{ x }",1, 0, FUNC_gsl_sf_bessel_j0,0,0,0,0 },
	//{ "gsl_sf_bessel_j1","{ x }",1, 0, FUNC_gsl_sf_bessel_j1,0,0,0,0 },
	{ "gsl_sf_bessel_j2","{ x }",1, 0, FUNC_gsl_sf_bessel_j2,0,0,0,0 },
	{ "gsl_sf_bessel_jl","{ l } , { x }",2, 0, FUNC_gsl_sf_bessel_jl,0,0,0,0 },
	//{ "gsl_sf_bessel_y0","{ x }",1, 0, FUNC_gsl_sf_bessel_y0,0,0,0,0 },
	//{ "gsl_sf_bessel_y1","{ x }",1, 0, FUNC_gsl_sf_bessel_y1,0,0,0,0 },
	{ "gsl_sf_bessel_y2","{ x }",1, 0, FUNC_gsl_sf_bessel_y2,0,0,0,0 },
	{ "gsl_sf_bessel_yl","{ l } , { x }",2, 0, FUNC_gsl_sf_bessel_yl,0,0,0,0 },
	//{ "gsl_sf_bessel_i0_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_i0_scaled,0,0,0,0 },
	//{ "gsl_sf_bessel_i1_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_i1_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_i2_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_i2_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_il_scaled","{ l } , { x }",2, 0, FUNC_gsl_sf_bessel_il_scaled,0,0,0,0 },
	//{ "gsl_sf_bessel_k0_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_k0_scaled,0,0,0,0 },
	//{ "gsl_sf_bessel_k1_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_k1_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_k2_scaled","{ x }",1, 0, FUNC_gsl_sf_bessel_k2_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_kl_scaled","{ l } , { x }",2, 0, FUNC_gsl_sf_bessel_kl_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_Jnu","{ nu } , { x }",2, 0, FUNC_gsl_sf_bessel_Jnu,0,0,0,0 },
	{ "gsl_sf_bessel_Ynu","{ nu } , { x }",2, 0, FUNC_gsl_sf_bessel_Ynu,0,0,0,0 },
	{ "gsl_sf_bessel_Inu_scaled","{ nu } , { x }",2, 0, FUNC_gsl_sf_bessel_Inu_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_Inu","{ nu } , { x }",2, 0, FUNC_gsl_sf_bessel_Inu,0,0,0,0 },
	{ "gsl_sf_bessel_Knu_scaled","{ nu } , { x }",2, 0, FUNC_gsl_sf_bessel_Knu_scaled,0,0,0,0 },
	{ "gsl_sf_bessel_Knu","{ nu } , { x }",2, 0, FUNC_gsl_sf_bessel_Knu,0,0,0,0 },
	{ "gsl_sf_bessel_lnKnu","{ nu } , { x }",2, 0, FUNC_gsl_sf_bessel_lnKnu,0,0,0,0 },
	{ "gsl_sf_bessel_zero_J0","{ s }",1, 0, FUNC_gsl_sf_bessel_zero_J0,0,0,0,0 },
	{ "gsl_sf_bessel_zero_J1","{ s }",1, 0, FUNC_gsl_sf_bessel_zero_J1,0,0,0,0 },
	{ "gsl_sf_bessel_zero_Jnu","{ nu } , { s }",2, 0, FUNC_gsl_sf_bessel_zero_Jnu,0,0,0,0 },
	
{ "gsl_sf_clausen","{ x }",1, 0, FUNC_gsl_sf_clausen,0,0,0,0 },


{ "gsl_sf_coupling_3j","{ two_ja } , { two_jb } , { two_jc } , { two_ma } , { two_mb } , { two_mc }",6, 0, FUNC_gsl_sf_coupling_3j,0,0,0,0 },
{ "gsl_sf_coupling_6j","{ two_ja } , { two_jb } , { two_jc } , { two_jd } , { two_je } , { two_jf }",6, 0, FUNC_gsl_sf_coupling_6j,0,0,0,0 },
{ "gsl_sf_coupling_RacahW","{ two_ja } , { two_jb } , { two_jc } , { two_jd } , { two_je } , { two_jf }",6, 0, FUNC_gsl_sf_coupling_RacahW,0,0,0,0 },
{ "gsl_sf_coupling_9j","{ two_ja } , { two_jb } , { two_jc } , { two_jd } , { two_je } , { two_jf } , { two_jg } , { two_jh } , { two_ji }",9, 0, FUNC_gsl_sf_coupling_9j,0,0,0,0 },
//{ "gsl_sf_coupling_6j_INCORRECT","{ two_ja, { two_jb, { two_jc, { two_jd } , { two_je } , { two_jf }",6, 0, FUNC_gsl_sf_coupling_6j_INCORRECT,0,0,0,0 },

{ "gsl_sf_hydrogenicR_1","{ Z } , { r }",2, 0, FUNC_gsl_sf_hydrogenicR_1,0,0,0,0 },
{ "gsl_sf_hydrogenicR","{ n } , { l } , { z } , { r }",4, 0, FUNC_gsl_sf_hydrogenicR,0,0,0,0 },

{ "gsl_sf_dawson","{ x }",1, 0, FUNC_gsl_sf_dawson,0,0,0,0 },

{ "gsl_sf_debye_1","{ x }",1, 0, FUNC_gsl_sf_debye_1,0,0,0,0 },
{ "gsl_sf_debye_2","{ x }",1, 0, FUNC_gsl_sf_debye_2,0,0,0,0 },
{ "gsl_sf_debye_3","{ x }",1, 0, FUNC_gsl_sf_debye_3,0,0,0,0 },
{ "gsl_sf_debye_4","{ x }",1, 0, FUNC_gsl_sf_debye_4,0,0,0,0 },
{ "gsl_sf_debye_5","{ x }",1, 0, FUNC_gsl_sf_debye_5,0,0,0,0 },
{ "gsl_sf_debye_6","{ x }",1, 0, FUNC_gsl_sf_debye_6,0,0,0,0 },

{ "gsl_sf_dilog","{ x }",1, 0, FUNC_gsl_sf_dilog,0,0,0,0 },

{ "gsl_sf_multiply","{ x } , { y } ",2, 0, FUNC_gsl_sf_multiply,0,0,0,0 },

{ "gsl_sf_ellint_Kcomp","{ k }",1, 0, FUNC_gsl_sf_ellint_Kcomp,0,0,0,0 },
{ "gsl_sf_ellint_Ecomp","{ k }",1, 0, FUNC_gsl_sf_ellint_Ecomp,0,0,0,0 },
{ "gsl_sf_ellint_Pcomp","{ k } , { n }",2, 0, FUNC_gsl_sf_ellint_Pcomp,0,0,0,0 },
{ "gsl_sf_ellint_Dcomp","{ k }",1, 0, FUNC_gsl_sf_ellint_Dcomp,0,0,0,0 },
{ "gsl_sf_ellint_F","{ phi } , { k }",2, 0, FUNC_gsl_sf_ellint_F,0,0,0,0 },
{ "gsl_sf_ellint_E","{ phi } , { k }",2, 0, FUNC_gsl_sf_ellint_E,0,0,0,0 },
{ "gsl_sf_ellint_P","{ phi } , { k } , { n }",3, 0, FUNC_gsl_sf_ellint_P,0,0,0,0 },
{ "gsl_sf_ellint_D","{ phi } , { k }",2, 0, FUNC_gsl_sf_ellint_D,0,0,0,0 },
{ "gsl_sf_ellint_RC","{ x } , { y } ",2, 0, FUNC_gsl_sf_ellint_RC,0,0,0,0 },
{ "gsl_sf_ellint_RD","{ x } , { y } , { z }",3, 0, FUNC_gsl_sf_ellint_RD,0,0,0,0 },
{ "gsl_sf_ellint_RF","{ x } , { y } , { z }",3, 0, FUNC_gsl_sf_ellint_RF,0,0,0,0 },
{ "gsl_sf_ellint_RJ","{ x } , { y } , { z } , { p }",4, 0, FUNC_gsl_sf_ellint_RJ,0,0,0,0 },

{ "gsl_sf_erfc","{ x }",1, 0, FUNC_gsl_sf_erfc,0,0,0,0 },

{ "gsl_sf_log_erfc","{ x }",1, 0, FUNC_gsl_sf_log_erfc,0,0,0,0 },
{ "gsl_sf_erf","{ x }",1, 0, FUNC_gsl_sf_erf,0,0,0,0 },
{ "gsl_sf_erf_Z","{ x }",1, 0, FUNC_gsl_sf_erf_Z,0,0,0,0 },
{ "gsl_sf_erf_Q","{ x }",1, 0, FUNC_gsl_sf_erf_Q,0,0,0,0 },
{ "gsl_sf_hazard","{ x }",1, 0, FUNC_gsl_sf_hazard,0,0,0,0 },


{ "gsl_sf_exp","{ x }",1, 0, FUNC_gsl_sf_exp,0,0,0,0 },

{ "gsl_sf_exp_mult","{ x } , { y } ",2, 0, FUNC_gsl_sf_exp_mult,0,0,0,0 },
{ "gsl_sf_expm1","{ x }",1, 0, FUNC_gsl_sf_expm1,0,0,0,0 },
{ "gsl_sf_exprel","{ x }",1, 0, FUNC_gsl_sf_exprel,0,0,0,0 },
{ "gsl_sf_exprel_2","{ x }",1, 0, FUNC_gsl_sf_exprel_2,0,0,0,0 },
{ "gsl_sf_exprel_n","{ n } , { x }",2, 0, FUNC_gsl_sf_exprel_n,0,0,0,0 },

{ "gsl_sf_expint_E1","{ x }",1, 0, FUNC_gsl_sf_expint_E1,0,0,0,0 },
{ "gsl_sf_expint_E2","{ x }",1, 0, FUNC_gsl_sf_expint_E2,0,0,0,0 },
{ "gsl_sf_expint_En","{ n } , { x }",2, 0, FUNC_gsl_sf_expint_En,0,0,0,0 },
{ "gsl_sf_expint_E1_scaled","{ x }",1, 0, FUNC_gsl_sf_expint_E1_scaled,0,0,0,0 },
{ "gsl_sf_expint_E2_scaled","{ x }",1, 0, FUNC_gsl_sf_expint_E2_scaled,0,0,0,0 },
{ "gsl_sf_expint_En_scaled","{ n } , { x }",2, 0, FUNC_gsl_sf_expint_En_scaled,0,0,0,0 },
{ "gsl_sf_expint_Ei","{ x }",1, 0, FUNC_gsl_sf_expint_Ei,0,0,0,0 },
{ "gsl_sf_expint_Ei_scaled","{ x }",1, 0, FUNC_gsl_sf_expint_Ei_scaled,0,0,0,0 },
{ "gsl_sf_Shi","{ x }",1, 0, FUNC_gsl_sf_Shi,0,0,0,0 },
{ "gsl_sf_Chi","{ x }",1, 0, FUNC_gsl_sf_Chi,0,0,0,0 },
{ "gsl_sf_expint_3","{ x }",1, 0, FUNC_gsl_sf_expint_3,0,0,0,0 },
{ "gsl_sf_Si","{ x }",1, 0, FUNC_gsl_sf_Si,0,0,0,0 },
{ "gsl_sf_Ci","{ x }",1, 0, FUNC_gsl_sf_Ci,0,0,0,0 },
{ "gsl_sf_atanint","{ x }",1, 0, FUNC_gsl_sf_atanint,0,0,0,0 },


{ "gsl_sf_fermi_dirac_m1","{ x }",1, 0, FUNC_gsl_sf_fermi_dirac_m1,0,0,0,0 },
{ "gsl_sf_fermi_dirac_0","{ x }",1, 0, FUNC_gsl_sf_fermi_dirac_0,0,0,0,0 },
{ "gsl_sf_fermi_dirac_1","{ x }",1, 0, FUNC_gsl_sf_fermi_dirac_1,0,0,0,0 },
{ "gsl_sf_fermi_dirac_2","{ x }",1, 0, FUNC_gsl_sf_fermi_dirac_2,0,0,0,0 },
{ "gsl_sf_fermi_dirac_int","{ j, { x }",2, 0, FUNC_gsl_sf_fermi_dirac_int,0,0,0,0 },
{ "gsl_sf_fermi_dirac_mhalf","{ x }",1, 0, FUNC_gsl_sf_fermi_dirac_mhalf,0,0,0,0 },
{ "gsl_sf_fermi_dirac_half","{ x }",1, 0, FUNC_gsl_sf_fermi_dirac_half,0,0,0,0 },
{ "gsl_sf_fermi_dirac_3half","{ x }",1, 0, FUNC_gsl_sf_fermi_dirac_3half,0,0,0,0 },
{ "gsl_sf_fermi_dirac_inc_0","{ x } , { b }",2, 0, FUNC_gsl_sf_fermi_dirac_inc_0,0,0,0,0 },

{ "gsl_sf_lngamma","{ x }",1, 0, FUNC_gsl_sf_lngamma,0,0,0,0 },
{ "gsl_sf_gamma","{ x }",1, 0, FUNC_gsl_sf_gamma,0,0,0,0 },
{ "gsl_sf_gammastar","{ x }",1, 0, FUNC_gsl_sf_gammastar,0,0,0,0 },
{ "gsl_sf_gammainv","{ x }",1, 0, FUNC_gsl_sf_gammainv,0,0,0,0 },
{ "gsl_sf_taylorcoeff","{ n } , { x }",2, 0, FUNC_gsl_sf_taylorcoeff,0,0,0,0 },
{ "gsl_sf_fact"," { n }",1, 0, FUNC_gsl_sf_fact,0,0,0,0 },
{ "gsl_sf_doublefact"," { n }",1, 0, FUNC_gsl_sf_doublefact,0,0,0,0 },
{ "gsl_sf_lnfact"," { n }",1, 0, FUNC_gsl_sf_lnfact,0,0,0,0 },
{ "gsl_sf_lndoublefact"," { n }",1, 0, FUNC_gsl_sf_lndoublefact,0,0,0,0 },
{ "gsl_sf_lnchoose"," { n } ,  { m }",2, 0, FUNC_gsl_sf_lnchoose,0,0,0,0 },
{ "gsl_sf_choose"," { n } ,  { m }",2, 0, FUNC_gsl_sf_choose,0,0,0,0 },
{ "gsl_sf_lnpoch","{ a } , { x }",2, 0, FUNC_gsl_sf_lnpoch,0,0,0,0 },
{ "gsl_sf_poch","{ a } , { x }",2, 0, FUNC_gsl_sf_poch,0,0,0,0 },
{ "gsl_sf_pochrel","{ a } , { x }",2, 0, FUNC_gsl_sf_pochrel,0,0,0,0 },
{ "gsl_sf_gamma_inc_Q","{ a } , { x }",2, 0, FUNC_gsl_sf_gamma_inc_Q,0,0,0,0 },
{ "gsl_sf_gamma_inc_P","{ a } , { x }",2, 0, FUNC_gsl_sf_gamma_inc_P,0,0,0,0 },
{ "gsl_sf_gamma_inc","{ a } , { x }",2, 0, FUNC_gsl_sf_gamma_inc,0,0,0,0 },
{ "gsl_sf_lnbeta","{ a } , { b } ",2, 0, FUNC_gsl_sf_lnbeta,0,0,0,0 },
{ "gsl_sf_beta","{ a } , { b } ",2, 0, FUNC_gsl_sf_beta,0,0,0,0 },
{ "gsl_sf_beta_inc","{ a } , { b } , { x }",3, 0, FUNC_gsl_sf_beta_inc,0,0,0,0 },

{ "gsl_sf_gegenpoly_1","{ lambda } , { x }",2, 0, FUNC_gsl_sf_gegenpoly_1,0,0,0,0 },
{ "gsl_sf_gegenpoly_2","{ lambda } , { x }",2, 0, FUNC_gsl_sf_gegenpoly_2,0,0,0,0 },
{ "gsl_sf_gegenpoly_3","{ lambda } , { x }",2, 0, FUNC_gsl_sf_gegenpoly_3,0,0,0,0 },
{ "gsl_sf_gegenpoly_n","{ n } , { lambda } , { x }",3, 0, FUNC_gsl_sf_gegenpoly_n,0,0,0,0 },

{ "gsl_sf_hermite_prob","{ n } , { x }",2, 0, FUNC_gsl_sf_hermite_prob,0,0,0,0 },
{ "gsl_sf_hermite_prob_der","{ m } , { n } , { x }",3, 0, FUNC_gsl_sf_hermite_prob_der,0,0,0,0 },
{ "gsl_sf_hermite_phys","{ n } , { x }",2, 0, FUNC_gsl_sf_hermite_phys,0,0,0,0 },
{ "gsl_sf_hermite_phys_der","{ m } , { n } , { x }",3, 0, FUNC_gsl_sf_hermite_phys_der,0,0,0,0 },
{ "gsl_sf_hermite_func","{ n } , { x }",2, 0, FUNC_gsl_sf_hermite_func,0,0,0,0 },
//{ "gsl_sf_hermite_prob_series","{ n } , { x } , double * a",3, 0, FUNC_gsl_sf_hermite_prob_series,0,0,0,0 },
//{ "gsl_sf_hermite_phys_series","{ n } , { x } , double * a",3, 0, FUNC_gsl_sf_hermite_phys_series,0,0,0,0 },
//{ "gsl_sf_hermite_func_series","{ n } , { x } , double * a",3, 0, FUNC_gsl_sf_hermite_func_series,0,0,0,0 },
{ "gsl_sf_hermite_func_der","{ m } , { n } , { x }",3, 0, FUNC_gsl_sf_hermite_func_der,0,0,0,0 },
{ "gsl_sf_hermite_prob_zero","{ n } , { s }",2, 0, FUNC_gsl_sf_hermite_prob_zero,0,0,0,0 },
{ "gsl_sf_hermite_phys_zero","{ n } , { s }",2, 0, FUNC_gsl_sf_hermite_phys_zero,0,0,0,0 },
{ "gsl_sf_hermite_func_zero","{ n } , { s }",2, 0, FUNC_gsl_sf_hermite_func_zero,0,0,0,0 },

{ "gsl_sf_laguerre_1","{ a } , { x }",2, 0, FUNC_gsl_sf_laguerre_1,0,0,0,0 },
{ "gsl_sf_laguerre_2","{ a } , { x }",2, 0, FUNC_gsl_sf_laguerre_2,0,0,0,0 },
{ "gsl_sf_laguerre_3","{ a } , { x }",2, 0, FUNC_gsl_sf_laguerre_3,0,0,0,0 },
{ "gsl_sf_laguerre_n","{ n } , { a } , { x }",3, 0, FUNC_gsl_sf_laguerre_n,0,0,0,0 },

{ "gsl_sf_lambert_W0","{ x }",1, 0, FUNC_gsl_sf_lambert_W0,0,0,0,0 },
{ "gsl_sf_lambert_Wm1","{ x }",1, 0, FUNC_gsl_sf_lambert_Wm1,0,0,0,0 },

{ "gsl_sf_log","{ x }",1, 0, FUNC_gsl_sf_log,0,0,0,0 },
{ "gsl_sf_log_abs","{ x }",1, 0, FUNC_gsl_sf_log_abs,0,0,0,0 },
{ "gsl_sf_log_1plusx","{ x }",1, 0, FUNC_gsl_sf_log_1plusx,0,0,0,0 },
{ "gsl_sf_log_1plusx_mx","{ x }",1, 0, FUNC_gsl_sf_log_1plusx_mx,0,0,0,0 },

{ "gsl_sf_pow_int","{ x } , { n }",2, 0, FUNC_gsl_sf_pow_int,0,0,0,0 },

{ "gsl_sf_psi_int","{ n }",1, 0, FUNC_gsl_sf_psi_int,0,0,0,0 },
{ "gsl_sf_psi","{ x }",1, 0, FUNC_gsl_sf_psi,0,0,0,0 },
{ "gsl_sf_psi_1piy","{ y }",1, 0, FUNC_gsl_sf_psi_1piy,0,0,0,0 },
{ "gsl_sf_psi_1_int","{ n }",1, 0, FUNC_gsl_sf_psi_1_int,0,0,0,0 },
{ "gsl_sf_psi_1","{ x }",1, 0, FUNC_gsl_sf_psi_1,0,0,0,0 },
{ "gsl_sf_psi_n","{ n } , { x }",2, 0, FUNC_gsl_sf_psi_n,0,0,0,0 },

{ "gsl_sf_synchrotron_1","{ x }",1, 0, FUNC_gsl_sf_synchrotron_1,0,0,0,0 },
{ "gsl_sf_synchrotron_2","{ x }",1, 0, FUNC_gsl_sf_synchrotron_2,0,0,0,0 },

{ "gsl_sf_transport_2","{ x }",1, 0, FUNC_gsl_sf_transport_2,0,0,0,0 },
{ "gsl_sf_transport_3","{ x }",1, 0, FUNC_gsl_sf_transport_3,0,0,0,0 },
{ "gsl_sf_transport_4","{ x }",1, 0, FUNC_gsl_sf_transport_4,0,0,0,0 },
{ "gsl_sf_transport_5","{ x }",1, 0, FUNC_gsl_sf_transport_5,0,0,0,0 },

{ "gsl_sf_sin","{ x }",1, 0, FUNC_gsl_sf_sin,0,0,0,0 },
{ "gsl_sf_cos","{ x }",1, 0, FUNC_gsl_sf_cos,0,0,0,0 },
{ "gsl_sf_hypot","{ x } , { y }",2, 0, FUNC_gsl_sf_hypot,0,0,0,0 },
{ "gsl_sf_sinc","{ x }",1, 0, FUNC_gsl_sf_sinc,0,0,0,0 },
{ "gsl_sf_lnsinh","{ x }",1, 0, FUNC_gsl_sf_lnsinh,0,0,0,0 },
{ "gsl_sf_lncosh","{ x }",1, 0, FUNC_gsl_sf_lncosh,0,0,0,0 },
{ "gsl_sf_angle_restrict_symm","{ theta }",1, 0, FUNC_gsl_sf_angle_restrict_symm,0,0,0,0 },
{ "gsl_sf_angle_restrict_pos","{ theta }",1, 0, FUNC_gsl_sf_angle_restrict_pos,0,0,0,0 },

{ "gsl_sf_zeta_int","{ n }",1, 0, FUNC_gsl_sf_zeta_int,0,0,0,0 },
{ "gsl_sf_zeta","{ s }",1, 0, FUNC_gsl_sf_zeta,0,0,0,0 },
{ "gsl_sf_zetam1","{ s }",1, 0, FUNC_gsl_sf_zetam1,0,0,0,0 },
{ "gsl_sf_zetam1_int","{ s }",1, 0, FUNC_gsl_sf_zetam1_int,0,0,0,0 },
{ "gsl_sf_hzeta","{ s } , { q }",2, 0, FUNC_gsl_sf_hzeta,0,0,0,0 },
{ "gsl_sf_eta_int","{ n }",1, 0, FUNC_gsl_sf_eta_int,0,0,0,0 },
{ "gsl_sf_eta","{ s }",1, 0, FUNC_gsl_sf_eta,0,0,0,0 },


//{ "gsl_cheb_alloc","{order}", 1, 0, FUNC_gsl_cheb_alloc,1,0,0,0 },

	
	
	{'\0',0,0,0}} ;


/****************************************************************
 5 External function definitions
 ****************************************************************/

 /**************************
  This function is a version check - it is required to be sure
  the external functions are compatible with the current Vensim
  version. Note that for 5.8c this number has changed but you can
  simply update this version number, the set_gv function and the
  funcversion_info function (these 2 return different value types)
  make no other changes to your external functions and they will
  work. To simplify use with different configurations (ie the 
  Model Reader and DLLs) we recommend that you not link with 
  vensim.lib or vensimdp.lib and replace

  vensim_error_message with (*VENGV->error_message)
  vensim_alloc_simmem with (*VENGV->alloc_simmem)
  vensim_execute_curloop with (*VENGV->execute_curloop)

**********************/

int VEFCC version_info()
 {
  return(EXTERNAL_VERSION) ;
  }

/* When you make changes to functions update this. If Vensim opens a .vmf file
   that references aexternal functions and there is a mismatch a message will
   be given indicating that the model should be reformed and cleaned 
   - if you return 0 no checking will occur

  If you have multiple external function libraries you can also use this to 
  signal when a model is not matched to the library (though it won't indicate
  which library should be used) */
unsigned short VEFCC funcversion_info()
{
   return(1) ;
   }

int VEFCC set_gv(GLOB_VARS *vgv) 
 {
  VENGV = vgv ;
  if(!VENGV || 
     VENGV->vgv_magic_start != VGV_MAGIC_START ||
     VENGV->vgv_magic_end != VGV_MAGIC_END)
     return 0 ;
  return 1 ;
  }

  /* ****************************
   This function is _exported and called multiple times at Vensim 
   startup with an index  - it returns 1 on success and 0 to 
   indicate the end of the function list.  For convenience the structure
   defined in section 3 is used, but all the functions could also be declared
   with a switch statement on i
 *****************************************************************/

int VEFCC user_definition(
   int i, /* an index for requesting information - this is mapped to Flist
             but could be used another way - vensim repeatedly calls
             user_definition with i bigger by 1 until user_definition returns
             0 */
   unsigned char **sym,/* the name of the function to be used in the Vensim model */
   unsigned char **argument_desc, /* description of arguments to be used by the function */
   int *num_arg, /* the number of arguments (in Vensim) the function takes 
                    note that for user loop functions this will be one less
                    than the number of arguments the function actually takes on */
   int *num_vector, /* the number of arguments that are passed as real number vectors */
   int *func_index, /* a number between 0 and 254 that identifies the function
                       vensim_external is called with this number */
   int *dim_act,  /* reserved - for doing dimensional analysis but not implemented */
   int *modify,  /* a flag to indicate that the function will modify value that
                    are passed to it - 
                    0 is a normal function that does not modify its argument
                    1 is a function that does modify arguments
                    2 is a function that modifies arguments and serves as a solver
                      of a simultaneous set of conditions as FIND_ZERO */
  int *num_loop, /* the number of loops that are managed by the function - 
                    this is nonzero (normally 1 or 2) for a function that 
                    needs to return a vector or matrix of values - if this is
                    nonzero Vensim will put a pointer to the vector or array to
                    be filled in and pass it as the first argument to the function 
                    NOTE use -1 for a constdef function and -2 for a datadef function */

  int *num_literal, /* the number of literals that are passed to the function - 
                       arguments are always passed in the order literals, 
                       lookups, vectors, numbers - if num_loop is set the
                       first argument is a vector even if num_literal is positive */
  int *num_lookup  /* the number of lookup functions passed - this structure is
                      not currently accessible but will be made so in the future */
  )
 {

  if(Flist[i].sym) {
     *sym = (unsigned char *)Flist[i].sym ;
     *argument_desc = (unsigned char *)Flist[i].argument_desc ;
     *num_arg = Flist[i].num_args ;
     *num_vector = Flist[i].num_vector ;
     *func_index = Flist[i].func_index ;
     *dim_act = 0 ;
     *modify = Flist[i].modify ;
     *num_loop = Flist[i].num_loop ;
     *num_literal = Flist[i].num_literal ;
     *num_lookup = Flist[i].num_lookup ;
     return(1) ;
     }
  return(0) ; /* indicating the end of the list */
  }

/*********************************************************************
 6 - startup and shutdown routines
 *********************************************************************
    these two functions (if they exist and are exported) 
    are called before the simulation starts and
    after it ends - in a normal simulation the order is
       simulation_setup(1) ;
       simulation_setup(0) ;
       simulation_shutdown(0) ;
       simulation_shutdown(1) ;
    for an optimization it the middle two calls are repeated for 
    every simulation - the setup routine should return 0 on failure
    the return value is only used when iniflag == 1.  If the function
    returns 0 simulation will not proceed. 
 ******************************************************************/

CFUNCTION int VEFCC simulation_setup(int iniflag)
{
	return(1) ;
}
CFUNCTION int VEFCC simulation_shutdown(int finalflag)
{
	return(1) ;
}

/* this is a safety function to validate vector ranges when passing
   vectors to Vensim - you don't need to use it but it will help to 
   prevent nasty memory errors */
static void validate_vector_arg(VECTOR_ARG *v,int firstind,int lastind)
{
	int itemp ;
	if(firstind > lastind)
	{
		itemp = firstind ;
		firstind = lastind ;
		lastind = itemp ;
	}
	if ( v->vals + firstind < v->firstval 
			|| v->vals+lastind > v->firstval + v->dim_info->tot_vol)
	{
		(*VENGV->error_message)(VERROR,(unsigned char *)"Vector argument out of bounds") ;
		v->vals[0] = (COMPREAL)0.0 ;
		v->vals[0] = (COMPREAL)(1.0/v->vals[0]) ; /* generate a floating point exception */
	}
}


/*********************************************************************
 6 - vensim_external - the actual external function call
 *********************************************************************
   note that all the functions doing floating point are passed and 
   return doubles to prevent any compiler specific problems from 
   arising 
 ******************************************************************/

CFUNCTION int VEFCC vensim_external(VV *val,int nval,int funcid)
{
	double rval ;
	
	switch(funcid)
	{
	case FUNC_gsl_sf_hyperg_0F1:
		rval = gsl_sf_hyperg_0F1(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_hyperg_1F1:
		rval = gsl_sf_hyperg_1F1(val[0].val, val[1].val, val[2].val);
		break;
	case FUNC_gsl_sf_hyperg_U:
		rval = gsl_sf_hyperg_U(val[0].val, val[1].val, val[2].val);
		break;
	case FUNC_gsl_sf_hyperg_2F1:
		rval = gsl_sf_hyperg_2F1(val[0].val, val[1].val, val[2].val, val[3].val);
		break;
	case FUNC_gsl_sf_hyperg_2F1_conj:
		rval = gsl_sf_hyperg_2F1_conj(val[0].val, val[1].val, val[2].val, val[3].val);
		break;
	case FUNC_gsl_sf_hyperg_2F1_renorm:
		rval = gsl_sf_hyperg_2F1_renorm(val[0].val, val[1].val, val[2].val, val[3].val);
		break;
	case FUNC_gsl_sf_hyperg_2F1_conj_renorm:
		rval = gsl_sf_hyperg_2F1_conj_renorm(val[0].val, val[1].val, val[2].val, val[3].val);
		break;
	case FUNC_gsl_sf_hyperg_2F0:
		rval = gsl_sf_hyperg_2F0(val[0].val, val[1].val, val[2].val);
		break;





	case FUNC_gsl_sf_airy_Ai:
		rval = gsl_sf_airy_Ai(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_airy_Bi:
		rval = gsl_sf_airy_Bi(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_airy_Ai_scaled:
		rval = gsl_sf_airy_Ai_scaled(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_airy_Bi_scaled:
		rval = gsl_sf_airy_Bi_scaled(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_airy_Ai_deriv:
		rval = gsl_sf_airy_Ai_deriv(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_airy_Bi_deriv:
		rval = gsl_sf_airy_Bi_deriv(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_airy_Ai_deriv_scaled:
		rval = gsl_sf_airy_Ai_deriv_scaled(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_airy_Bi_deriv_scaled:
		rval = gsl_sf_airy_Bi_deriv_scaled(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_airy_zero_Ai:
		rval = gsl_sf_airy_zero_Ai((unsigned int)val[0].val);
		break;
	case FUNC_gsl_sf_airy_zero_Bi:
		rval = gsl_sf_airy_zero_Bi((unsigned int)val[0].val);
		break;
	case FUNC_gsl_sf_airy_zero_Ai_deriv:
		rval = gsl_sf_airy_zero_Ai_deriv((unsigned int)val[0].val);
		break;
	case FUNC_gsl_sf_airy_zero_Bi_deriv:
		rval = gsl_sf_airy_zero_Bi_deriv((unsigned int)val[0].val);
		break;
		
	case FUNC_gsl_sf_bessel_J0:
		rval = gsl_sf_bessel_J0(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_J1:
		rval = gsl_sf_bessel_J1(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_Jn:
		rval = gsl_sf_bessel_Jn((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_Y0:
		rval = gsl_sf_bessel_Y0(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_Y1:
		rval = gsl_sf_bessel_Y1(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_Yn:
		rval = gsl_sf_bessel_Yn((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_I0:
		rval = gsl_sf_bessel_I0(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_I1:
		rval = gsl_sf_bessel_I1(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_In:
		rval = gsl_sf_bessel_In((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_I0_scaled:
		rval = gsl_sf_bessel_I0_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_I1_scaled:
		rval = gsl_sf_bessel_I1_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_In_scaled:
		rval = gsl_sf_bessel_In_scaled((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_K0:
		rval = gsl_sf_bessel_K0(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_K1:
		rval = gsl_sf_bessel_K1(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_Kn:
		rval = gsl_sf_bessel_Kn((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_K0_scaled:
		rval = gsl_sf_bessel_K0_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_K1_scaled:
		rval = gsl_sf_bessel_K1_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_Kn_scaled:
		rval = gsl_sf_bessel_Kn_scaled((int)val[0].val, val[1].val);
		break;
	//case FUNC_gsl_sf_bessel_j0:
	//	rval = gsl_sf_bessel_j0(val[0].val);
	//	break;
	//case FUNC_gsl_sf_bessel_j1:
	//	rval = gsl_sf_bessel_j1(val[0].val);
	//	break;
	case FUNC_gsl_sf_bessel_j2:
		rval = gsl_sf_bessel_j2(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_jl:
		rval = gsl_sf_bessel_jl((int)val[0].val, val[1].val);
		break;
	//case FUNC_gsl_sf_bessel_y0:
	//	rval = gsl_sf_bessel_y0(val[0].val);
	//	break;
	//case FUNC_gsl_sf_bessel_y1:
	//	rval = gsl_sf_bessel_y1(val[0].val);
	//	break;
	case FUNC_gsl_sf_bessel_y2:
		rval = gsl_sf_bessel_y2(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_yl:
		rval = gsl_sf_bessel_yl((int)val[0].val, val[1].val);
		break;
	//case FUNC_gsl_sf_bessel_i0_scaled:
	//	rval = gsl_sf_bessel_i0_scaled(val[0].val);
	//	break;
	//case FUNC_gsl_sf_bessel_i1_scaled:
	//	rval = gsl_sf_bessel_i1_scaled(val[0].val);
	//	break;
	case FUNC_gsl_sf_bessel_i2_scaled:
		rval = gsl_sf_bessel_i2_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_il_scaled:
		rval = gsl_sf_bessel_il_scaled((int)val[0].val, val[1].val);
		break;
	//case FUNC_gsl_sf_bessel_k0_scaled:
	//	rval = gsl_sf_bessel_k0_scaled(val[0].val);
	//	break;
	//case FUNC_gsl_sf_bessel_k1_scaled:
	//	rval = gsl_sf_bessel_k1_scaled(val[0].val);
	//	break;
	case FUNC_gsl_sf_bessel_k2_scaled:
		rval = gsl_sf_bessel_k2_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_bessel_kl_scaled:
		rval = gsl_sf_bessel_kl_scaled((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_Jnu:
		rval = gsl_sf_bessel_Jnu(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_Ynu:
		rval = gsl_sf_bessel_Ynu(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_Inu_scaled:
		rval = gsl_sf_bessel_Inu_scaled(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_Inu:
		rval = gsl_sf_bessel_Inu(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_Knu_scaled:
		rval = gsl_sf_bessel_Knu_scaled(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_Knu:
		rval = gsl_sf_bessel_Knu(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_lnKnu:
		rval = gsl_sf_bessel_lnKnu(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_bessel_zero_J0:
		rval = gsl_sf_bessel_zero_J0((int)val[0].val);
		break;
	case FUNC_gsl_sf_bessel_zero_J1:
		rval = gsl_sf_bessel_zero_J1((int)val[0].val);
		break;
	case FUNC_gsl_sf_bessel_zero_Jnu:
		rval = gsl_sf_bessel_zero_Jnu(val[0].val, (unsigned int)val[1].val);
		break;
		
	case FUNC_gsl_sf_clausen:
		rval = gsl_sf_clausen(val[0].val);
		break;
		
			
	case FUNC_gsl_sf_coupling_3j:
		rval = gsl_sf_coupling_3j((int)val[0].val, (int)val[1].val, (int)val[2].val, (int)val[3].val, (int)val[4].val, (int)val[5].val);
		break;
	case FUNC_gsl_sf_coupling_6j:
		rval = gsl_sf_coupling_6j((int)val[0].val, (int)val[1].val, (int)val[2].val, (int)val[3].val, (int)val[4].val, (int)val[5].val);
		break;
	case FUNC_gsl_sf_coupling_RacahW:
		rval = gsl_sf_coupling_RacahW((int)val[0].val, (int)val[1].val, (int)val[2].val, (int)val[3].val, (int)val[4].val, (int)val[5].val);
		break;
	case FUNC_gsl_sf_coupling_9j:
		rval = gsl_sf_coupling_9j((int)val[0].val, (int)val[1].val, (int)val[2].val, (int)val[3].val, (int)val[4].val, (int)val[5].val, (int)val[6].val, (int)val[7].val, (int)val[8].val);
		break;
//	case FUNC_gsl_sf_coupling_6j_INCORRECT:
//		rval = gsl_sf_coupling_6j_INCORRECT(val[0].val, val[1].val, val[2].val, val[3].val, val[4].val, val[5].val);
//		break;
		
	case FUNC_gsl_sf_hydrogenicR_1:
		rval = gsl_sf_hydrogenicR_1(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_hydrogenicR:
		rval = gsl_sf_hydrogenicR((int)val[0].val, (int)val[1].val, val[2].val, val[3].val);
		break;
		
	case FUNC_gsl_sf_dawson:
		rval = gsl_sf_dawson(val[0].val);
		break;
		
	case FUNC_gsl_sf_debye_1:
		rval = gsl_sf_debye_1(val[0].val);
		break;
	case FUNC_gsl_sf_debye_2:
		rval = gsl_sf_debye_2(val[0].val);
		break;
	case FUNC_gsl_sf_debye_3:
		rval = gsl_sf_debye_3(val[0].val);
		break;
	case FUNC_gsl_sf_debye_4:
		rval = gsl_sf_debye_4(val[0].val);
		break;
	case FUNC_gsl_sf_debye_5:
		rval = gsl_sf_debye_5(val[0].val);
		break;
	case FUNC_gsl_sf_debye_6:
		rval = gsl_sf_debye_6(val[0].val);
		break;
		
	case FUNC_gsl_sf_dilog:
		rval = gsl_sf_dilog(val[0].val);
		break;
		
	case FUNC_gsl_sf_multiply:
		rval = gsl_sf_multiply(val[0].val, val[1].val);
		break;
		
	case FUNC_gsl_sf_ellint_Kcomp:
		rval = gsl_sf_ellint_Kcomp(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_Ecomp:
		rval = gsl_sf_ellint_Ecomp(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_Pcomp:
		rval = gsl_sf_ellint_Pcomp(val[0].val, val[2].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_Dcomp:
		rval = gsl_sf_ellint_Dcomp(val[0].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_F:
		rval = gsl_sf_ellint_F(val[0].val, val[1].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_E:
		rval = gsl_sf_ellint_E(val[0].val, val[1].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_P:
		rval = gsl_sf_ellint_P(val[0].val, val[1].val, val[2].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_D:
		rval = gsl_sf_ellint_D(val[0].val, val[1].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_RC:
		rval = gsl_sf_ellint_RC(val[0].val, val[1].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_RD:
		rval = gsl_sf_ellint_RD(val[0].val, val[1].val, val[2].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_RF:
		rval = gsl_sf_ellint_RF(val[0].val, val[1].val, val[2].val, GSL_PREC_DOUBLE);
		break;
	case FUNC_gsl_sf_ellint_RJ:
		rval = gsl_sf_ellint_RJ(val[0].val, val[1].val, val[2].val, val[3].val, GSL_PREC_DOUBLE);
		break;
		
	case FUNC_gsl_sf_erfc:
		rval = gsl_sf_erfc(val[0].val);
		break;
		
	case FUNC_gsl_sf_log_erfc:
		rval = gsl_sf_log_erfc(val[0].val);
		break;
	case FUNC_gsl_sf_erf:
		rval = gsl_sf_erf(val[0].val);
		break;
	case FUNC_gsl_sf_erf_Z:
		rval = gsl_sf_erf_Z(val[0].val);
		break;
	case FUNC_gsl_sf_erf_Q:
		rval = gsl_sf_erf_Q(val[0].val);
		break;
	case FUNC_gsl_sf_hazard:
		rval = gsl_sf_hazard(val[0].val);
		break;
		
			
	case FUNC_gsl_sf_exp:
		rval = gsl_sf_exp(val[0].val);
		break;
		
	case FUNC_gsl_sf_exp_mult:
		rval = gsl_sf_exp_mult(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_expm1:
		rval = gsl_sf_expm1(val[0].val);
		break;
	case FUNC_gsl_sf_exprel:
		rval = gsl_sf_exprel(val[0].val);
		break;
	case FUNC_gsl_sf_exprel_2:
		rval = gsl_sf_exprel_2(val[0].val);
		break;
	case FUNC_gsl_sf_exprel_n:
		rval = gsl_sf_exprel_n((int)val[0].val, val[1].val);
		break;
		
	case FUNC_gsl_sf_expint_E1:
		rval = gsl_sf_expint_E1(val[0].val);
		break;
	case FUNC_gsl_sf_expint_E2:
		rval = gsl_sf_expint_E2(val[0].val);
		break;
	case FUNC_gsl_sf_expint_En:
		rval = gsl_sf_expint_En((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_expint_E1_scaled:
		rval = gsl_sf_expint_E1_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_expint_E2_scaled:
		rval = gsl_sf_expint_E2_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_expint_En_scaled:
		rval = gsl_sf_expint_En_scaled((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_expint_Ei:
		rval = gsl_sf_expint_Ei(val[0].val);
		break;
	case FUNC_gsl_sf_expint_Ei_scaled:
		rval = gsl_sf_expint_Ei_scaled(val[0].val);
		break;
	case FUNC_gsl_sf_Shi:
		rval = gsl_sf_Shi(val[0].val);
		break;
	case FUNC_gsl_sf_Chi:
		rval = gsl_sf_Chi(val[0].val);
		break;
	case FUNC_gsl_sf_expint_3:
		rval = gsl_sf_expint_3(val[0].val);
		break;
	case FUNC_gsl_sf_Si:
		rval = gsl_sf_Si(val[0].val);
		break;
	case FUNC_gsl_sf_Ci:
		rval = gsl_sf_Ci(val[0].val);
		break;
	case FUNC_gsl_sf_atanint:
		rval = gsl_sf_atanint(val[0].val);
		break;
		
			
	case FUNC_gsl_sf_fermi_dirac_m1:
		rval = gsl_sf_fermi_dirac_m1(val[0].val);
		break;
	case FUNC_gsl_sf_fermi_dirac_0:
		rval = gsl_sf_fermi_dirac_0(val[0].val);
		break;
	case FUNC_gsl_sf_fermi_dirac_1:
		rval = gsl_sf_fermi_dirac_1(val[0].val);
		break;
	case FUNC_gsl_sf_fermi_dirac_2:
		rval = gsl_sf_fermi_dirac_2(val[0].val);
		break;
	case FUNC_gsl_sf_fermi_dirac_int:
		rval = gsl_sf_fermi_dirac_int((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_fermi_dirac_mhalf:
		rval = gsl_sf_fermi_dirac_mhalf(val[0].val);
		break;
	case FUNC_gsl_sf_fermi_dirac_half:
		rval = gsl_sf_fermi_dirac_half(val[0].val);
		break;
	case FUNC_gsl_sf_fermi_dirac_3half:
		rval = gsl_sf_fermi_dirac_3half(val[0].val);
		break;
	case FUNC_gsl_sf_fermi_dirac_inc_0:
		rval = gsl_sf_fermi_dirac_inc_0(val[0].val, val[1].val);
		break;
		
	case FUNC_gsl_sf_lngamma:
		rval = gsl_sf_lngamma(val[0].val);
		break;
	case FUNC_gsl_sf_gamma:
		rval = gsl_sf_gamma(val[0].val);
		break;
	case FUNC_gsl_sf_gammastar:
		rval = gsl_sf_gammastar(val[0].val);
		break;
	case FUNC_gsl_sf_gammainv:
		rval = gsl_sf_gammainv(val[0].val);
		break;
	case FUNC_gsl_sf_taylorcoeff:
		rval = gsl_sf_taylorcoeff((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_fact:
		rval = gsl_sf_fact((int)val[0].val);
		break;
	case FUNC_gsl_sf_doublefact:
		rval = gsl_sf_doublefact((int)val[0].val);
		break;
	case FUNC_gsl_sf_lnfact:
		rval = gsl_sf_lnfact((int)val[0].val);
		break;
	case FUNC_gsl_sf_lndoublefact:
		rval = gsl_sf_lndoublefact((int)val[0].val);
		break;
	case FUNC_gsl_sf_lnchoose:
		rval = gsl_sf_lnchoose((int)val[0].val, (int)val[1].val);
		break;
	case FUNC_gsl_sf_choose:
		rval = gsl_sf_choose((unsigned int)val[0].val, (unsigned int)val[1].val);
		break;
	case FUNC_gsl_sf_lnpoch:
		rval = gsl_sf_lnpoch(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_poch:
		rval = gsl_sf_poch(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_pochrel:
		rval = gsl_sf_pochrel(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_gamma_inc_Q:
		rval = gsl_sf_gamma_inc_Q(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_gamma_inc_P:
		rval = gsl_sf_gamma_inc_P(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_gamma_inc:
		rval = gsl_sf_gamma_inc(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_lnbeta:
		rval = gsl_sf_lnbeta(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_beta:
		rval = gsl_sf_beta(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_beta_inc:
		rval = gsl_sf_beta_inc(val[0].val, val[1].val, val[2].val);
		break;
		
	case FUNC_gsl_sf_gegenpoly_1:
		rval = gsl_sf_gegenpoly_1(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_gegenpoly_2:
		rval = gsl_sf_gegenpoly_2(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_gegenpoly_3:
		rval = gsl_sf_gegenpoly_3(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_gegenpoly_n:
		rval = gsl_sf_gegenpoly_n((int)val[0].val, val[1].val, val[2].val);
		break;
		
	case FUNC_gsl_sf_hermite_prob:
		rval = gsl_sf_hermite_prob((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_hermite_prob_der:
		rval = gsl_sf_hermite_prob_der((int)val[0].val, (int)val[1].val, val[2].val);
		break;
	case FUNC_gsl_sf_hermite_phys:
		rval = gsl_sf_hermite_phys((int)val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_hermite_phys_der:
		rval = gsl_sf_hermite_phys_der((int)val[0].val, (int)val[1].val, val[2].val);
		break;
	case FUNC_gsl_sf_hermite_func:
		rval = gsl_sf_hermite_func((int)val[0].val, val[1].val);
		break;
	//case FUNC_gsl_sf_hermite_prob_series:
	//	rval = gsl_sf_hermite_prob_series(int n, double x, double * a);
	//	break;
	//case FUNC_gsl_sf_hermite_phys_series:
	//	rval = gsl_sf_hermite_phys_series(int n, double x, double * a);
	//	break;
	//case FUNC_gsl_sf_hermite_func_series:
	//	rval = gsl_sf_hermite_func_series(int n, double x, double * a);
	//	break;
	case FUNC_gsl_sf_hermite_func_der:
		rval = gsl_sf_hermite_func_der((int)val[0].val, (int)val[1].val, val[1].val);
		break;
	case FUNC_gsl_sf_hermite_prob_zero:
		rval = gsl_sf_hermite_prob_zero((int)val[0].val, (int)val[1].val);
		break;
	case FUNC_gsl_sf_hermite_phys_zero:
		rval = gsl_sf_hermite_phys_zero((int)val[0].val, (int)val[1].val);
		break;
	case FUNC_gsl_sf_hermite_func_zero:
		rval = gsl_sf_hermite_func_zero((int)val[0].val, (int)val[1].val);
		break;
		
	case FUNC_gsl_sf_laguerre_1:
		rval = gsl_sf_laguerre_1(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_laguerre_2:
		rval = gsl_sf_laguerre_2(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_laguerre_3:
		rval = gsl_sf_laguerre_3(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_laguerre_n:
		rval = gsl_sf_laguerre_n((int)val[0].val, val[1].val, val[2].val);
		break;
		
	case FUNC_gsl_sf_lambert_W0:
		rval = gsl_sf_lambert_W0(val[0].val);
		break;
	case FUNC_gsl_sf_lambert_Wm1:
		rval = gsl_sf_lambert_Wm1(val[0].val);
		break;
		
	case FUNC_gsl_sf_log:
		rval = gsl_sf_log(val[0].val);
		break;
	case FUNC_gsl_sf_log_abs:
		rval = gsl_sf_log_abs(val[0].val);
		break;
	case FUNC_gsl_sf_log_1plusx:
		rval = gsl_sf_log_1plusx(val[0].val);
		break;
	case FUNC_gsl_sf_log_1plusx_mx:
		rval = gsl_sf_log_1plusx_mx(val[0].val);
		break;
		
	case FUNC_gsl_sf_pow_int:
		rval = gsl_sf_pow_int(val[0].val, (int)val[1].val);
		break;
		
	case FUNC_gsl_sf_psi_int:
		rval = gsl_sf_psi_int((int)val[0].val);
		break;
	case FUNC_gsl_sf_psi:
		rval = gsl_sf_psi(val[0].val);
		break;
	case FUNC_gsl_sf_psi_1piy:
		rval = gsl_sf_psi_1piy(val[0].val);
		break;
	case FUNC_gsl_sf_psi_1_int:
		rval = gsl_sf_psi_1_int((int)val[0].val);
		break;
	case FUNC_gsl_sf_psi_1:
		rval = gsl_sf_psi_1(val[0].val);
		break;
	case FUNC_gsl_sf_psi_n:
		rval = gsl_sf_psi_n((int)val[0].val, val[1].val);
		break;
		
	case FUNC_gsl_sf_synchrotron_1:
		rval = gsl_sf_synchrotron_1(val[0].val);
		break;
	case FUNC_gsl_sf_synchrotron_2:
		rval = gsl_sf_synchrotron_2(val[0].val);
		break;
		
	case FUNC_gsl_sf_transport_2:
		rval = gsl_sf_transport_2(val[0].val);
		break;
	case FUNC_gsl_sf_transport_3:
		rval = gsl_sf_transport_3(val[0].val);
		break;
	case FUNC_gsl_sf_transport_4:
		rval = gsl_sf_transport_4(val[0].val);
		break;
	case FUNC_gsl_sf_transport_5:
		rval = gsl_sf_transport_5(val[0].val);
		break;
		
	case FUNC_gsl_sf_sin:
		rval = gsl_sf_sin(val[0].val);
		break;
	case FUNC_gsl_sf_cos:
		rval = gsl_sf_cos(val[0].val);
		break;
	case FUNC_gsl_sf_hypot:
		rval = gsl_sf_hypot(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_sinc:
		rval = gsl_sf_sinc(val[0].val);
		break;
	case FUNC_gsl_sf_lnsinh:
		rval = gsl_sf_lnsinh(val[0].val);
		break;
	case FUNC_gsl_sf_lncosh:
		rval = gsl_sf_lncosh(val[0].val);
		break;
	case FUNC_gsl_sf_angle_restrict_symm:
		rval = gsl_sf_angle_restrict_symm(val[0].val);
		break;
	case FUNC_gsl_sf_angle_restrict_pos:
		rval = gsl_sf_angle_restrict_pos(val[0].val);
		break;
		
	case FUNC_gsl_sf_zeta_int:
		rval = gsl_sf_zeta_int((int)val[0].val);
		break;
	case FUNC_gsl_sf_zeta:
		rval = gsl_sf_zeta(val[0].val);
		break;
	case FUNC_gsl_sf_zetam1:
		rval = gsl_sf_zetam1(val[0].val);
		break;
	case FUNC_gsl_sf_zetam1_int:
		rval = gsl_sf_zetam1_int((int)val[0].val);
		break;
	case FUNC_gsl_sf_hzeta:
		rval = gsl_sf_hzeta(val[0].val, val[1].val);
		break;
	case FUNC_gsl_sf_eta_int:
		rval = gsl_sf_eta_int((int)val[0].val);
		break;
	case FUNC_gsl_sf_eta:
		rval = gsl_sf_eta(val[0].val);
		break;

	/*
	case FUNC_gsl_cheb_alloc:
	{
		gsl_cheb_series *_series = gsl_cheb_alloc((size_t)val[1].val);
		//Now copy back the series to the array
		for (long i = 0; i < _series->order; i++)
		{
			val[0].vec->vals[i] = (COMPREAL)_series->c[i];
		}
	}
	break;
	*/



	default :
		return(0) ; /* indicate an error condition to Vensim */
	}
	/* set val[0], this value will be used in the equation output */
	val[0].val = (COMPREAL)rval ;
	return(1) ; /* a 1 return value signals vensim of successful completetion */
}

